;;Developed for the FLATLAND ARCHITECTURAL DRAFTING ENHANCEMENT version 3.5
;;for AutoCAD - Copyright 1994, Mark Ash III
;RECDWG: Recdwg is FLATLAND's drawing list recorder. The command, which loads
;and executes manually from tablet coordinates Y26 and Y27, functions
;automatically when you start a new drawing or . Information compiled by recdwg
;is stored in a file called "drawing.lst" in the same directory as the current
;drawing and can be accessed with a text editor or by using the DOS "type"
;command.
;COMMAND USE
;Command: recdwg
;Enter the drawing type  <default>: (Enter a text string [i.e. "floor plan"].
;  The maximum allowable string is 14 letters.)
;Enter any remarks  <default>: (Enter a text string [i.e. "first floor west"]
;  The maximum string length is 32 letters.)
;endhlp
;recdwg.lsp 3 1 91
(defun c:recdwg (/ reck fdis remk dt file str1 txt ork)
(setvar "cmdecho" 0)
(setq
  ork nil
  dname (getvar "dwgname")
)
(while(=(getvar "dwgname")"UNNAMED")(progn
  (princ "\nThe current file is unnamed...")
  (setq dname(strcase(getstring "\nEnter the file name to save to: ")))
  (if(/=(substr dname 1 3)(substr(getvar "dwgprefix")1 3))
    (setq dname (strcat(getvar "dwgprefix")dname)))
  (if(/=(findfile(strcat dname ".dwg"))nil)(progn
    (initget 2 "Y N")
    (if(= lork nil)(setq lork "N"))
    (progn(princ "\nThe specified file name already exists...")
    (princ "\nOverwrite? (Y/N) <")(princ lork)
    (princ ">:")(setq ork(getkword))(cond((null ork)(setq ork lork))))
    (setq ork (strcase ork))(setq lork ork)
                            )
  )
  (cond
    ((and(/= ork nil)(= ork "Y"))(progn
      (princ "\nSaving drawing to file ")(princ dname)(princ "\n\n")
      (command "saveas" dname "Y")
                                ))
    ((= ork nil)(command "saveas" dname))
  )
                                 )
)
(if(=(substr dname 2 1)":")
  (setq dname (substr dname (strlen(getvar "dwgprefix")))))
(if(=(substr dname 1 1)"\\")(setq dname(substr dname 2)))
(while(<(strlen dname)10)(setq dname (strcat dname " ")))
(while(>(strlen dname)10)(setq dname (substr dname 1 (-(strlen dname)1))))
(if(/=(strcase(substr dname 1 4))"HOLD")(setq *error* recdwgerr))

(while(= fdis nil)
  (if (= lfdis nil) (setq lfdis "FLOOR PLAN"))
  (progn (princ "\nEnter the drawing type <") (princ lfdis)(princ ">:")
  (setq fdis (getstring t)) (cond ((= fdis "") (setq fdis lfdis))))
  (setq fdis (strcase fdis))(setq lfdis fdis)
  (if(>(strlen fdis)14)(progn
    (setq fdis nil)
    (princ "\nToo long, won't fit! ")
                       )
  )
)
(while(= remk nil)
  (if (= lremk nil) (setq lremk ""))
  (progn (princ "\nEnter any remarks  <") (princ lremk)(princ ">:")
  (setq remk (getstring t)) (cond ((= remk "") (setq remk lremk))))
  (setq remk (strcase remk))(setq lremk remk)
  (if(>(strlen remk)36)(progn
    (setq remk nil)
    (princ "\nToo long, won't fit! ")
                       )
  )
)
(setq dt (rtos(getvar "cdate")2 0))
(setq dt (strcat(substr dt 5 2)"/"(substr dt 7 2)"/"(substr dt 3 2)))

(setq str1 (strcat dname dt))
(while(<(strlen str1)20)(setq str1 (strcat str1 " ")))
(while(<(strlen fdis)15)(setq fdis (strcat fdis " ")))
    (setq file (open(strcat(getvar "dwgprefix")"drawing.lst")"a"))
(princ (strcat "\n" str1 fdis remk)file)
(close file)
(setq *error* cranerr)
(terpri)
)

(defun recdwgerr (msg)
(if(/= file nil)(close file))
(if(/= file1 nil)(close file1))
(if(/= file2 nil)(close file2))
(if(/= file3 nil)(close file3))
(if(/= file4 nil)(close file4))
(if(= msg "bad argument type")(setq msg "Command terminated."))
(if (/= msg "Function canceled.")
  (princ(strcat "\n" msg))
)
(command ".quit" "y")
(terpri)
)
